this.name        = "Hyperdrives"; 
this.author      = "Redspear"; 
this.copyright   = "2016 Redspear";
this.licence     = "CC BY-NC-SA 4.0"; 
this.description = "Variable hyperdrives and jump ranges for player ships"; 
this.version     = "0.6";

"use strict";

// determine player ship hyperdrive range

this.startUp = this.playerBoughtNewShip = this.equipmentAdded = this.equipmentRemoved = this.equipmentDamaged = this.equipmentRepaired = function()
{
	//	EASY-TWEAK section - note the advice (or not, none of my business really...)
	
	var maxRange = 7; //	no point making this any higher than 7 with standard oolite and ranges increment by 0.4 so if you make it less than 6.8...
	var longRange = 6.4;	//	almost always the greatest distance for a jump is 6.8 LY, so this should probably be a lower value than that
	var shortRange = 6;	//	6.0 is the minimum to make every system accessible from somewhere in galaxy 1
	var minRange = 5.6;	//	5.6 will make it possible to get to lots of places but it might require taking the long way round
	
	//	equipment modifiers (EEU, ANA, WHScanner & GalDrive dictate jump range capability)
	
	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") === "EQUIPMENT_OK")
		{this._rangeLimit = maxRange;
		}
		
	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") != "EQUIPMENT_OK")
		{this._rangeLimit = maxRange;
		}
		
	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") === "EQUIPMENT_OK")
		{this._rangeLimit = maxRange;
		}
		
	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") != "EQUIPMENT_OK")
		{this._rangeLimit = longRange;
		}		
		
	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") === "EQUIPMENT_OK")
		{this._rangeLimit = maxRange;
		}	

	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") != "EQUIPMENT_OK")
		{this._rangeLimit = longRange;
		}			
	
	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") === "EQUIPMENT_OK")
		{this._rangeLimit = maxRange;
		}
		
	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") != "EQUIPMENT_OK")
		{this._rangeLimit = longRange;
		}		
		
	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") === "EQUIPMENT_OK")
		{this._rangeLimit = longRange;
		}	
		
	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") != "EQUIPMENT_OK")
		{this._rangeLimit = shortRange;
		}		
	
	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") === "EQUIPMENT_OK")
		{this._rangeLimit = longRange;
		}
		
	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") != "EQUIPMENT_OK")
		{this._rangeLimit = shortRange;
		}		
		
	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") === "EQUIPMENT_OK")
		{this._rangeLimit = longRange;
		}	
		
	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") != "EQUIPMENT_OK")
		{this._rangeLimit = shortRange;
		}		

	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") === "EQUIPMENT_OK")
		{this._rangeLimit = shortRange;
		}
		
	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") != "EQUIPMENT_OK")
		{this._rangeLimit = minRange;
		}
		
}

this.startUpComplete = function ()
{
	this._fuelMalus = 0;	//	needed for navigation charts
}

// represent range limits on navigation charts

this.guiScreenChanged = function(toGUI)
{
	if (toGUI == "GUI_SCREEN_SHORT_RANGE_CHART")
		{if (_fuelMalus == 0 && player.ship.fuel > _rangeLimit)
			{this._fuelMalus = player.ship.fuel - _rangeLimit;	//	range circle may not exceed jump limit
			player.ship.fuel = _rangeLimit;	//	temporary fuel 'loss'
			}
		else
		{player.ship.fuel = player.ship.fuel;
		this._fuelMalus = _fuelMalus;}	//	as you were...
	}
		
	if (toGUI != "GUI_SCREEN_SHORT_RANGE_CHART" && toGUI != "GUI_SCREEN_LONG_RANGE_CHART")	
		{player.ship.fuel = player.ship.fuel + _fuelMalus;	//	any 'lost' fuel restored
		this._fuelMalus = 0;}	//	reset fuel 'debt'
}

// abort jump if range limit exceeded

this.playerStartedJumpCountdown = function(standard)
{

	if (System.infoForSystem(galaxyNumber, system.ID).distanceToSystem(System.infoForSystem(galaxyNumber, player.ship.nextSystem)) > _rangeLimit)
		{player.ship.cancelHyperspaceCountdown();
		player.consoleMessage ("Present Hyperdrive Capability Insufficient");}	//	let player know what went wrong (or at least give them a clue)
}